# LightingCompositingDetail Struct Reference

Inheritance diagram for LightingCompositingDetail:

List of all members.

## Public Member Functions
| LightingCompositingDetail ()
void | Reset ()
void | InterpolateDetails (const LightingCompositingDetail &a, const LightingCompositingDetail &b, real32 t, boolean computeShadow, boolean computeAtmosphere, boolean computeVolumePrimitive)
## Public Attributes
TMCColorRGBA | fResColor
| Resulting color from lighting & shading (alpha should be premultiplied).
TMCColorRGB | fBackground
| Background component (composited as normal).
TMCColorRGB | fAmbient
| Ambient containing ambient occlusion factor if any (composited as additive : C = C + C_this, for each component (red, green and blue) ).
TMCColorRGB | fDiffuseLight
| Diffuse (composited as additive). NOTE: It should contains shadowing except if the fComputeSeparatedShadow flag is set on the the IllumSettings.
TMCColorRGB | fSpecularLight
| Specular (composited as additive). NOTE: It should contains shadowing except if the fComputeSeparatedShadow flag is set on the the IllumSettings.
TMCColorRGB | fLightShadow
| Shadow (multiplies fDiffuseLight + fSpecularLight). NOTE: It should only be computed when the fComputeSeparatedShadow flag is set on the the IllumSettings.
TMCColorRGB | fGlow
| Glow (composited as additive).
TMCColorRGB | fReflection
| Reflection (composited as additive).
TMCColorRGB | fRefraction
| Refraction and transparency (composited as additive).
TMCColorRGB | fGlobalIllumination
| Global illumination (composited as additive).
TMCColorRGB | fCaustics
| Caustics (composited as additive).
TMCColorRGB | fSubsurfaceScattering
| Subsurface scattering (composited as additive).
TColorRGBLinearEffect | fAtmosphere
| Atmosphere linear components. NOTE: It should only be computed when the fComputeAtmosphereDetails flag is set on the the IllumSettings.
TColorRGBLinearEffect | fVolumePrimitives
| Volume primitives linear components. NOTE: It should only be computed when the fComputeVolumePrimitivesDetails flag is set on the the IllumSettings.
TMCColorRGB | fVolumetricEffects
| Volume effects linear components. NOTE: It should only be computed when the fComputeVolumetricEffectsDetails flag is set on the the IllumSettings.
real | fAmbientOcclusionFactor
| Ambient occlusion factor (this is not composited as it should already be included in the fAmbient field).

## Detailed Description

Struct used to get details information about the lighting of a point regarding multi-passes. The content need to be filled in order to be supported correctly by the multi-pass rendering module.

## Constructor & Destructor Documentation

LightingCompositingDetail::LightingCompositingDetail | ( |  | ) | `[inline]`

## Member Function Documentation

void LightingCompositingDetail::InterpolateDetails | ( | const LightingCompositingDetail & | a,
|  | const LightingCompositingDetail & | b,
|  | real32 | t,
|  | boolean | computeShadow,
|  | boolean | computeAtmosphere,
|  | boolean | computeVolumePrimitive |
| ) |  |  |

void LightingCompositingDetail::Reset | ( |  | ) | `[inline]`

## Member Data Documentation

TMCColorRGB LightingCompositingDetail::fAmbient

Ambient containing ambient occlusion factor if any (composited as additive : C = C + C_this, for each component (red, green and blue) ).

real LightingCompositingDetail::fAmbientOcclusionFactor

Ambient occlusion factor (this is not composited as it should already be included in the fAmbient field).

TColorRGBLinearEffect LightingCompositingDetail::fAtmosphere

Atmosphere linear components. NOTE: It should only be computed when the fComputeAtmosphereDetails flag is set on the the IllumSettings.

TMCColorRGB LightingCompositingDetail::fBackground

Background component (composited as normal).

TMCColorRGB LightingCompositingDetail::fCaustics

Caustics (composited as additive).

TMCColorRGB LightingCompositingDetail::fDiffuseLight

Diffuse (composited as additive). NOTE: It should contains shadowing except if the fComputeSeparatedShadow flag is set on the the IllumSettings.

TMCColorRGB LightingCompositingDetail::fGlobalIllumination

Global illumination (composited as additive).

TMCColorRGB LightingCompositingDetail::fGlow

Glow (composited as additive).

TMCColorRGB LightingCompositingDetail::fLightShadow

Shadow (multiplies fDiffuseLight + fSpecularLight). NOTE: It should only be computed when the fComputeSeparatedShadow flag is set on the the IllumSettings.

TMCColorRGB LightingCompositingDetail::fReflection

Reflection (composited as additive).

TMCColorRGB LightingCompositingDetail::fRefraction

Refraction and transparency (composited as additive).

TMCColorRGBA LightingCompositingDetail::fResColor

Resulting color from lighting & shading (alpha should be premultiplied).

TMCColorRGB LightingCompositingDetail::fSpecularLight

Specular (composited as additive). NOTE: It should contains shadowing except if the fComputeSeparatedShadow flag is set on the the IllumSettings.

TMCColorRGB LightingCompositingDetail::fSubsurfaceScattering

Subsurface scattering (composited as additive).

TColorRGBLinearEffect LightingCompositingDetail::fVolumePrimitives

Volume primitives linear components. NOTE: It should only be computed when the fComputeVolumePrimitivesDetails flag is set on the the IllumSettings.

TMCColorRGB LightingCompositingDetail::fVolumetricEffects

Volume effects linear components. NOTE: It should only be computed when the fComputeVolumetricEffectsDetails flag is set on the the IllumSettings.

The documentation for this struct was generated from the following file:

- RenderTypes.h